package sun.awt.windows;

import java.awt.image.BufferedImage;
import sun.java2d.pipe.Region;
import java.awt.peer.ComponentPeer;
import java.awt.dnd.DropTarget;
import java.awt.Component;
import java.awt.Font;
import java.awt.Color;
import java.awt.Event;
import sun.awt.AWTAccessor;
import java.awt.Window;
import java.util.List;
import java.util.Iterator;
import java.awt.Dialog;
import java.util.Vector;
import java.awt.peer.DialogPeer;

class WPrintDialogPeer extends WWindowPeer implements DialogPeer
{
    private WComponentPeer parent;
    private Vector<WWindowPeer> blockedWindows;
    
    WPrintDialogPeer(WPrintDialog wPrintDialog) {
        super(wPrintDialog);
        this.blockedWindows = new Vector();
    }
    
    @Override
    void create(WComponentPeer parent) {
        this.parent = parent;
    }
    
    @Override
    protected void checkCreation() {
    }
    
    @Override
    protected void disposeImpl() {
        WToolkit.targetDisposedPeer(this.target, this);
    }
    
    private native boolean _show();
    
    @Override
    public void show() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ((WPrintDialog)WPrintDialogPeer.this.target).setRetVal(WPrintDialogPeer.access$000(WPrintDialogPeer.this));
                }
                catch (Exception ex) {}
                ((WPrintDialog)WPrintDialogPeer.this.target).setVisible(false);
            }
        }).start();
    }
    
    synchronized void setHWnd(long hwnd) {
        this.hwnd = hwnd;
        for (WWindowPeer wWindowPeer : this.blockedWindows) {
            if (hwnd != 0L) {
                wWindowPeer.modalDisable((Dialog)this.target, hwnd);
            }
            else {
                wWindowPeer.modalEnable((Dialog)this.target);
            }
        }
    }
    
    synchronized void blockWindow(WWindowPeer e) {
        this.blockedWindows.add(e);
        if (this.hwnd != 0L) {
            e.modalDisable((Dialog)this.target, this.hwnd);
        }
    }
    
    synchronized void unblockWindow(WWindowPeer o) {
        this.blockedWindows.remove(o);
        if (this.hwnd != 0L) {
            o.modalEnable((Dialog)this.target);
        }
    }
    
    @Override
    public void blockWindows(List<Window> list) {
        Iterator<Object> iterator = list.iterator();
        while (iterator.hasNext()) {
            WWindowPeer wWindowPeer = (WWindowPeer)AWTAccessor.getComponentAccessor().getPeer((Window)iterator.next());
            if (wWindowPeer != null) {
                this.blockWindow(wWindowPeer);
            }
            else {
                continue;
            }
        }
    }
    
    @Override
    public native void toFront();
    
    @Override
    public native void toBack();
    
    @Override
    void initialize() {
    }
    
    @Override
    public void updateAlwaysOnTopState() {
    }
    
    @Override
    public void setResizable(boolean b) {
    }
    
    @Override
    void hide() {
    }
    
    @Override
    void enable() {
    }
    
    @Override
    void disable() {
    }
    
    @Override
    public void reshape(int n, int n2, int n3, int n4) {
    }
    
    public boolean handleEvent(Event event) {
        return false;
    }
    
    @Override
    public void setForeground(Color color) {
    }
    
    @Override
    public void setBackground(Color color) {
    }
    
    @Override
    public void setFont(Font font) {
    }
    
    @Override
    public void updateMinimumSize() {
    }
    
    @Override
    public void updateIconImages() {
    }
    
    public boolean requestFocus(boolean b, boolean b2) {
        return false;
    }
    
    @Override
    public boolean requestFocus(Component component, boolean b, boolean b2, long n, CausedFocusEvent.Cause cause) {
        return false;
    }
    
    @Override
    public void updateFocusableWindowState() {
    }
    
    @Override
    void start() {
    }
    
    @Override
    public void beginValidate() {
    }
    
    @Override
    public void endValidate() {
    }
    
    void invalidate(int n, int n2, int n3, int n4) {
    }
    
    @Override
    public void addDropTarget(DropTarget dropTarget) {
    }
    
    @Override
    public void removeDropTarget(DropTarget dropTarget) {
    }
    
    @Override
    public void setZOrder(ComponentPeer componentPeer) {
    }
    
    private static native void initIDs();
    
    @Override
    public void applyShape(Region region) {
    }
    
    @Override
    public void setOpacity(float n) {
    }
    
    @Override
    public void setOpaque(boolean b) {
    }
    
    public void updateWindow(BufferedImage bufferedImage) {
    }
    
    @Override
    public void createScreenSurface(boolean b) {
    }
    
    @Override
    public void replaceSurfaceData() {
    }
    
    static boolean access$000(WPrintDialogPeer wPrintDialogPeer) {
        return wPrintDialogPeer._show();
    }
    
    static {
        initIDs();
    }
}
